﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Configuration;

namespace SchemaAPIDemo
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            TreeNode root= treeView1.Nodes.Add("All Databases");

            DataTable db = GetSchemaInfo(SchemaCollection.Databases, "");
            foreach (DataRow row in db.Rows)
            {
                AddNode(root, row["DATABASE_NAME"].ToString(),"Database",0);
            }
            //DataTable tables = cnn.GetSchema("Tables");
            //foreach (DataRow row in tables.Rows)
            //{
            //    TreeNode node = new TreeNode();
            //    node.Text = row["TABLE_NAME"].ToString();
            //    rootNode.Nodes.Add(node);

            //    string[] restrictions = new string[4];
            //    restrictions[2] = row["TABLE_NAME"].ToString();
            //    DataTable columns = cnn.GetSchema("Columns", restrictions);

            //    foreach (DataRow r in columns.Rows)
            //    {
            //        TreeNode childnode = new TreeNode();
            //        childnode.Text = r["COLUMN_NAME"].ToString() + " (" + r["DATA_TYPE"].ToString() + "," + (r["IS_NULLABLE"].ToString()=="YES"?"NULL":"NOT NULL") + ")";
            //        node.Nodes.Add(childnode);

            //    }
            //}



        }

        private TreeNode AddNode(TreeNode parent, string text,string tag,int imgIndex)
        {
            TreeNode child = new TreeNode(text);
            child.ImageIndex = imgIndex;
            child.SelectedImageIndex = imgIndex;
            child.Tag = tag;
            if (parent != null)
            {
                parent.Nodes.Add(child);
            }
            else
            {
                treeView1.Nodes.Add(child);
            }
            return child;
        }

        private DataTable GetSchemaInfo(SchemaCollection collection,string entity)
        {
            DataTable dt = null;
            string collectionname = "";
            string[] restrictions = null;

            switch (collection)
            {
                case SchemaCollection.Databases:
                    collectionname = "Databases";
                    if (entity != "")
                    {
                        restrictions = new string[1];
                        restrictions[0] = entity;
                    }
                    break;
                case SchemaCollection.Tables:
                    collectionname = "Tables";
                    if (entity != "")
                    {
                        restrictions = new string[4];
                        restrictions[0] = entity;
                    }
                    break;
                case SchemaCollection.Views:
                    collectionname = "Views";
                    if (entity != "")
                    {
                        restrictions = new string[3];
                        restrictions[0] = entity;
                    }
                    break;
                case SchemaCollection.Columns:
                    collectionname = "Columns";
                    if (entity != "")
                    {
                        restrictions = new string[4];
                        restrictions[2] = entity;
                    }
                    break;
                case SchemaCollection.ViewColumns:
                    collectionname = "ViewColumns";
                    if (entity != "")
                    {
                        restrictions = new string[4];
                        restrictions[2] = entity;
                    }
                    break;
                case SchemaCollection.StoredProcedures:
                    collectionname = "Procedures";
                    if (entity != "")
                    {
                        restrictions = new string[4];
                        restrictions[0] = entity;
                    }
                    break;
                case SchemaCollection.Parameters:
                    collectionname = "ProcedureParameters";
                    if (entity != "")
                    {
                        restrictions = new string[4];
                        restrictions[2] = entity;
                    }
                    break;
            }
            string strConn = ConfigurationManager.ConnectionStrings["connstr"].ConnectionString;
            SqlConnection cnn = new SqlConnection(strConn);
            cnn.Open();
            dt = cnn.GetSchema(collectionname,restrictions);
            cnn.Close();
            return dt;
        }

        private void treeView1_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            DataTable dt = null;
            if (e.Node.Tag != null)
            {
                e.Node.Nodes.Clear();

                switch (e.Node.Tag.ToString())
                {
                    case "Database":
                        TreeNode tblfolder=AddNode(e.Node, "Tables", null, 5);
                        tblfolder.SelectedImageIndex = 6;
                        TreeNode viewfolder = AddNode(e.Node, "Views", null, 5);
                        viewfolder.SelectedImageIndex = 6;
                        TreeNode procfolder = AddNode(e.Node, "Procedures", null, 5);
                        procfolder.SelectedImageIndex = 6;

                        dt = GetSchemaInfo(SchemaCollection.Tables, e.Node.Text);
                        foreach (DataRow row in dt.Rows)
                        {
                            AddNode(tblfolder, row["TABLE_NAME"].ToString(), "Table",1);
                        }
                        dt = GetSchemaInfo(SchemaCollection.StoredProcedures, e.Node.Text);
                        foreach (DataRow row in dt.Rows)
                        {
                            AddNode(procfolder, row["SPECIFIC_NAME"].ToString(), "Procedure",2);
                        }
                        dt = GetSchemaInfo(SchemaCollection.Views, e.Node.Text);
                        foreach (DataRow row in dt.Rows)
                        {
                            AddNode(viewfolder, row["TABLE_NAME"].ToString(), "View", 1);
                        }

                        break;
                    case "Table":
                        dt = GetSchemaInfo(SchemaCollection.Columns, e.Node.Text);
                        foreach (DataRow row in dt.Rows)
                        {
                            AddNode(e.Node, row["COLUMN_NAME"].ToString() + " (" + row["DATA_TYPE"].ToString() + "," + (row["IS_NULLABLE"].ToString() == "YES" ? "NULL" : "NOT NULL") + ")", "Column", 3);
                        }
                        break;
                    case "View":
                        dt = GetSchemaInfo(SchemaCollection.ViewColumns, e.Node.Text);
                        foreach (DataRow row in dt.Rows)
                        {
                            AddNode(e.Node, row["COLUMN_NAME"].ToString(), "ViewColumn", 3);
                        }
                        break;
                    case "Procedure":
                        dt = GetSchemaInfo(SchemaCollection.Parameters, e.Node.Text);
                        foreach (DataRow row in dt.Rows)
                        {
                            AddNode(e.Node, row["PARAMETER_NAME"].ToString() + " (" + row["DATA_TYPE"].ToString() + ")", "Parameter", 4);
                        }
                        break;
                }
            }
        }

    }





}
